/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __BBOX_H__
#define __BBOX_H__

#include "vector.h"

class bbox
{
public:
	vector min, max;

	void min_max(const vector *);

	inline void add(const vector *v)
		{ min.add(v); max.add(v); }

	inline void add(const bbox *b, const vector *v)
		{ min.add(&b->min, v); max.add(&b->max, v); }

	inline void sub(const vector *v)
		{ min.sub(v); max.sub(v); }

	inline void sub(const bbox *b, const vector *v)
		{ min.sub(&b->min, v); max.sub(&b->max, v); }
};

inline void bbox::min_max(const vector *v)
{
	float f;

	f = v->x();
	if (min.x() > f) min.set_x(f);
	if (max.x() < f) max.set_x(f);

	f = v->y();
	if (min.y() > f) min.set_y(f);
	if (max.y() < f) max.set_y(f);

	f = v->z();
	if (min.z() > f) min.set_z(f);
	if (max.z() < f) max.set_z(f);
}

#endif
