/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>

#include <GL/gl.h>

#include "config.h"

void screenshot(unsigned width, unsigned height)
{
	FILE *fp;
	DIR *dir;
	struct dirent *ent;
	unsigned i, l, num = 0;
	unsigned char *pixels;
	char name[32];

	if ( (dir = opendir("screen")) )
	{
		while ( (ent = readdir(dir)) )
		{
			i = strtoul(ent->d_name, 0, 10);
			if (i > num) num = i;
		}
		closedir(dir);
	}

	pixels = new unsigned char[l = (width * 3)];

	sprintf(name, "screen/%u.ppm", ++num);

	if ( (fp = fopen(name, "w")) )
	{
		fprintf(fp, "P6\n%u %u\n255\n", width, height);

		glReadBuffer(GL_FRONT);
		for (i = height - 1; i < height; i--)
		{
			glReadPixels(0, i, width, 1, GL_RGB, GL_UNSIGNED_BYTE,
				     pixels);
			fwrite(pixels, 1, l, fp);
		}

		fclose(fp);
	}
	
	delete pixels;
}
