/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __BUILTINS_H__
#define __BUILTINS_H__

#include "exec.h"

class fn_new : public function
{
 public:
	fn_new(list<function> *);
	virtual void call(unsigned);
};

class fn_delete : public function
{
 public:
	fn_delete(list<function> *);
	virtual void call(unsigned);
};

class fn_player : public function
{
 public:
	fn_player(list<function> *);
	virtual void call(unsigned);
};

class fn_camera : public function
{
 public:
	fn_camera(list<function> *);
	virtual void call(unsigned);
};

class fn_origin : public function
{
 public:
	fn_origin(list<function> *);
	virtual void call(unsigned);
};

class fn_angles : public function
{
 public:
	fn_angles(list<function> *);
	virtual void call(unsigned);
};

class fn_velocity : public function
{
 public:
	fn_velocity(list<function> *);
	virtual void call(unsigned);
};

class fn_avelocity : public function
{
 public:
	fn_avelocity(list<function> *);
	virtual void call(unsigned);
};

class fn_setorigin : public function
{
 public:
	fn_setorigin(list<function> *);
	virtual void call(unsigned);
};

class fn_setangles : public function
{
 public:
	fn_setangles(list<function> *);
	virtual void call(unsigned);
};

class fn_setvelocity : public function
{
 public:
	fn_setvelocity(list<function> *);
	virtual void call(unsigned);
};

class fn_setavelocity : public function
{
 public:
	fn_setavelocity(list<function> *);
	virtual void call(unsigned);
};

class fn_setsize : public function
{
 public:
	fn_setsize(list<function> *);
	virtual void call(unsigned);
};

class fn_setmodel : public function
{
 public:
	fn_setmodel(list<function> *);
	virtual void call(unsigned);
};

class fn_setframe : public function
{
 public:
	fn_setframe(list<function> *);
	virtual void call(unsigned);
};

class fn_waterheight : public function
{
 public:
	fn_waterheight(list<function> *);
	virtual void call(unsigned);
};

class fn_setwatertexture : public function
{
 public:
	fn_setwatertexture(list<function> *);
	virtual void call(unsigned);
};

class fn_setwaterheight : public function
{
 public:
	fn_setwaterheight(list<function> *);
	virtual void call(unsigned);
};

class fn_setclouds : public function
{
 public:
	fn_setclouds(list<function> *);
	virtual void call(unsigned);
};

class fn_setredsun : public function
{
 public:
	fn_setredsun(list<function> *);
	virtual void call(unsigned);
};

class fn_setbluesun : public function
{
 public:
	fn_setbluesun(list<function> *);
	virtual void call(unsigned);
};

class fn_hota : public function
{
 public:
	fn_hota(list<function> *);
	virtual void call(unsigned);
};

class fn_hotb : public function
{
 public:
	fn_hotb(list<function> *);
	virtual void call(unsigned);
};

class fn_gradient : public function
{
 public:
	fn_gradient(list<function> *);
	virtual void call(unsigned);
};

class fn_intersect : public function
{
 public:
	fn_intersect(list<function> *);
	virtual void call(unsigned);
};

class fn_keys : public function
{
 public:
	fn_keys(list<function> *);
	virtual void call(unsigned);
};

class fn_makevectors : public function
{
 public:
	fn_makevectors(list<function> *);
	virtual void call(unsigned);
};

class fn_v_forward : public function
{
 public:
	fn_v_forward(list<function> *);
	virtual void call(unsigned);
};

class fn_v_left : public function
{
 public:
	fn_v_left(list<function> *);
	virtual void call(unsigned);
};

class fn_v_up : public function
{
 public:
	fn_v_up(list<function> *);
	virtual void call(unsigned);
};

class fn_normalize : public function
{
 public:
	fn_normalize(list<function> *);
	virtual void call(unsigned);
};

class fn_precache_sound : public function
{
 public:
	fn_precache_sound(list<function> *);
	virtual void call(unsigned);
};

class fn_play_sound : public function
{
 public:
	fn_play_sound(list<function> *);
	virtual void call(unsigned);
};

class fn_play_sound_loop : public function
{
 public:
	fn_play_sound_loop(list<function> *);
	virtual void call(unsigned);
};

class fn_stop_sound : public function
{
 public:
	fn_stop_sound(list<function> *);
	virtual void call(unsigned);
};

#endif
