/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <GL/gl.h>

#include "misc.h"

int get_int(FILE *fp)
{
	unsigned char c[2];

	if (fread(c, 1, 2, fp) != 2)
		return -1;
	return ((c[1] << 8) + c[0]);
}

int get_fixed(FILE *fp, float *ptr)
{
	unsigned char c[2];

	if (fread(&c, 1, 2, fp) != 2)
		return -1;

	*ptr = (float(c[1]) / 256.0) + float((signed char)(c[0]));

	return 0;
}

int get_float(FILE *fp, float *ptr)
{
	union { int i; float f; } u;
	unsigned char c[4];

	if (fread(&c, 1, 4, fp) != 4)
		return -1;

	u.i = (c[3] << 24) + (c[2] << 16) + (c[1] << 8) + c[0];
	*ptr = u.f;

	return 0;
}
