/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __SKY_H__
#define __SKY_H__

#include "camera.h"
#include "matrix.h"
#include "gstring.h"

#include <GL/gl.h>

#define STAR_TEX_WIDTH 256

class star
{
 private:
	GLuint tex;
	vector vec[5];
	GLenum light;
	float dist;

 public:
	star(float);
	~star();

	void init(GLenum, float, float, float);
	void set(float, float);
	void draw();
};

class stars
{
 public:
	star red, blue;
	class texture *tex;
	float tn, td;

 public:
	stars();
	~stars();

	void init();
	void draw(camera *);

	inline void set_clouds(gstring *str, float n, float d)
		{ tex = str->tex(); tn = n; td = d; }
	inline void set_red(float a, float b) { red.set(a, b); }
	inline void set_blue(float a, float b) { blue.set(a, b); }
};

#endif
