/*
 *  Copyright (C) 2000 Christopher John Purnell
 *                     cjp@lost.org.uk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "vector.h"
#include "misc.h"

int vector::load(FILE *fp)
{
	char buf[6];

	if (fread(buf, 1, 6, fp) != 6)
		return -1;

	for(unsigned j = 0; j < 3; j++)
	{
		signed char c0 = buf[j*2];
		unsigned char c1 = buf[(j*2)+1];
		
		v[j] = (float(c1) / 256.0) + float(c0);
	}

	return 0;
}

int vector::load_fixed(FILE *fp)
{
	for(unsigned i = 0; i < 3; i++)
	{
		if (get_fixed(fp, &v[i]))
			return -1;
	}

	return 0;
}

int vector::load_float(FILE *fp)
{
	for(unsigned i = 0; i < 3; i++)
	{
		if (get_fixed(fp, &v[i]))
			return -1;
	}

	return 0;
}
